import cPickle as pickle
import numpy as np
from ciphers import *
import sys

if len(sys.argv) < 2:
    print "USAGE:", sys.argv[0], "filename"
    exit(0)

filename = sys.argv[1]
unigrams  = pickle.load(open('unigram_500000_sorted_list.pickle','rb'))
beam = pickle.load(open(filename,'rb'))

el = 'abcdefghijklmnopqrstuvwxyz'

def score_cipher_limit(cipher,n):
    uni_dict = {}
    c = np.unpackbits(np.array(buffer(cipher)))[:26*26].reshape((26,26))
    total = 0
    count = 0
    for w,score in unigrams:
        wx = encipher(c,w)
        if len(wx) == len(w) and wx in uni_dict:
            print w, wx, score
            total += score
            if count > n:
                break
            count += 1
        uni_dict[w] = score
    print '\n\nTOTAL SCORE: ', total


def score_cipher(cipher):
    uni_dict = {}
    c = np.unpackbits(np.array(buffer(cipher)))[:26*26].reshape((26,26))
    total = 0
    for w,score in unigrams:
        wx = encipher(c,w)
        if len(wx) == len(w) and wx in uni_dict:
            print w, ' & ', wx,' & ',  score[0], ' \\\\'
            total += score
        uni_dict[w] = score
    print '\n\nTOTAL SCORE: ', total

def cipher_word_set(cipher,n):
    s = set()
    uni_dict = {}
    c = np.unpackbits(np.array(buffer(cipher)))[:26*26].reshape((26,26))
    total = 0
    for w,score in unigrams:
        wx = encipher(c,w)
        if len(wx) == len(w) and len(w)>2 and wx in uni_dict:
            s.add(w)
            s.add(wx)
            if len(s) > n:
                break
        uni_dict[w] = score
    return s

def top_pair(cipher):
    uni_dict = {}
    c = np.unpackbits(np.array(buffer(cipher)))[:26*26].reshape((26,26))
    total = 0
    for w,score in unigrams:
        wx = encipher(c,w)
        if len(wx) == len(w) and wx in uni_dict:
            return wx, w
        uni_dict[w] = score


#if __name__ == '__main__':
#    top_pairs = set()
#    
#    for c in beam:
#        tp = top_pair(c[0])
#        if tp not in top_pairs:
